//SauvegardeCopie_502f.js
// 06.04.13 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Crer une copie de sauvegarde
//D'aprs un AppleScript, "Versioned Save", par Shane Stanley <sstanley@myriad-com.com.au>

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// appeler la fonction qui lit les rglages enregistrs
var defStr = getPrefs();
// extraire les valeurs
if (defStr != "") {
	var prefVal = defStr.split("\n");
	backupFolder = prefVal[0];
	nVal = prefVal[1]*1;
	sVal = prefVal[2]*1;
}
else {
	backupFolder = "";
	nVal =  5;
	sVal = 10;
}

// quand il n'y a pas de document ouvert, ne rgler que les prfrences
if (app.documents.length == 0) {
	askUser();
	exit();
}

// le document au premier plan
var curDoc = app.documents[0];

// mmoriser le chemin du fichier
try {
	docPath = curDoc.fullName;
	docName = curDoc.name;
}
catch (e) {
	alert ("Enregistrer le document.", "Attention");
	exit();
}

// appeler la fonction qui tente de localiser le dossier backup
var backupFolder = checkForFolder();

if (nVal > 0) {
	var sTag = curDoc.extractLabel("SK_vers_number");
	if (sTag == "") {
		curDoc.insertLabel("SK_vers_number", "1");
		var tagAsNum = 1;
		var sTag = "1";
	}
	else {
		var tagAsNum = (sTag*1)+1;
		sTag = "" + tagAsNum;
		curDoc.insertLabel("SK_vers_number", sTag);
	}
	var tagBit = ("00" + sTag).slice(-3);
}
// moriser le nom et le suffix
if (docName.indexOf(".indd") != -1) {
	var nameStub = docName.slice(0, -5);
	var curExt   = ".indd";
}
else {
	var nameStub = docName;
	var curExt   = "";
}
// enregistrer la copie backup
try {
	var curName = nameStub + "#" + tagBit + curExt;
	var bkpPath = backupFolder + "/" + curName;
	curDoc.save(new File(bkpPath));
}
catch (e) {
	alert ("Il n'est pas possible d'enregistrer la copie backup.\nUn probl de droits?", "Attention");
	exit();
}
// craser le fichier
try {
	curDoc.save(new File(docPath));
}
catch (e) {
}

// essayer de supprimer le fichier le plus ancien ds que le nombre dfini est dpass
var curDiff = tagAsNum - nVal;
if (curDiff > 0 && curDiff%sVal != 0) {
	var tagBit = ("00" + (tagAsNum-nVal)).slice(-3);
	var nameStub = docName.slice(0, -5);
	var oldFile  = backupFolder + "/" + nameStub + "#" + tagBit + curExt;
	File (oldFile).remove();
}

// informer l'utilisateur
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Enregistr:");
dlog.add("statictext", [80, 100, 320, 116], "\"" + curName + "\"");
dlog.show();
// une petite pause
$.sleep(1500);
// fermer la fentre
dlog.close();

// la fonction qui prpare les informations
function getPrefs() {
	var defStr = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Sauvegarde502.txt");
	}
	else {
		var f = new File("~/Library/Preferences/Sauvegarde502.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			defStr = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return defStr;
}

// la fonction qui teste la prsence du dossier
function checkForFolder() {
	if (backupFolder == "") {
		backupFolder = askUser();
	}
	else {
		var fo = Folder(backupFolder).exists; 
		if (fo == false) {
			backupFolder = askUser();
		}
	return backupFolder;
	}
}

// la fonction qui prpare le dialogue, l'affiche et convertit le rsultat
function askUser() {
	// faire slectionner le dossier...
	var backupFolder = Folder.selectDialog("Slectionner le dossier backup");
	if (backupFolder == null) {
		exit();
	}
	// supprimer des dialogues rests ouverts
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	// prparer le dialogue
	var labelWidth = 135;
	var aDialog = app.dialogs.add({name:"SauvegardeCopie"});
	with (aDialog.dialogColumns.add()) {
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Nombre de versions  conserver:"});
					var numberField = integerEditboxes.add({editValue:nVal, minWidth:36});
					staticTexts.add({staticLabel:" ", minWidth:12});
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Ne pas supprimer chaque"});
					var skipField = integerEditboxes.add({editValue:sVal, minWidth:36});
					staticTexts.add({staticLabel:"e version"});
				}
			}
		}
		with (aDialog.dialogColumns.add()) {
			staticTexts.add({staticLabel:" "});
		}
	}
	// afficher et exploiter le dialogue
	var dResult = aDialog.show();
	if (dResult == true) {
		var nValue = numberField.editValue;
		var sValue = skipField.editValue;
		var prefsList = new Array (backupFolder, nValue, sValue);
		var prefString = prefsList.join("\n");
		writeResult(prefString);
		return backupFolder;
	}
	else {
		aDialog.destroy();
		exit();
	}
	aDialog.destroy();
}

// crire le rsultat dans un fichier
function writeResult(prefString) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Sauvegarde502.txt");
	}
	else {
		var f = File("~/Library/Preferences/Sauvegarde502.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(prefString);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}